#include <stdio.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>

void rm_cr(char *pass_in, int cap_ln) {
	int pos = 0;
	while (pos < cap_ln) {
		char next = pass_in[pos];
		if (next == '\0')
			break;
		if (next == '\n') {
			pass_in[pos] = '\0';
			break;
		}
		pos++;
	}
	if (pos >= cap_ln) {
		pass_in[cap_ln - 1] = '\0';
	}
}

int main() {
	uint16_t expected_vals[24] = {0xd48c, 0x859c, 0x99ee, 0x4b2b, 0xd6e0, 0x770f, 0x6fe4, 0xab0f, 0x956b, 0xdcee, 0x692e, 0x96f5, 0xca56, 0xe67b, 0xbf02, 0xd3fc, 0x5759, 0x55b1, 0xf577, 0x1845, 0x2d34, 0x33c3, 0x18ee, 0x531a};
	uint16_t next_duet;
	uint8_t masks[] = {0x48, 0xb0, 0x88, 0x41, 0x9a, 0x8d, 0x9c, 0x3f, 0xf3, 0x61, 0xfa, 0x64,
		0xd2, 0x9a, 0x4c, 0x9d, 0x8d, 0xd6, 0x1b, 0x3a, 0x09, 0x9c, 0xc6, 0xb1,
		0x15, 0xf9, 0x3d, 0xa5, 0xf7, 0xf9, 0xbf, 0x26, 0x0a, 0x14, 0xe2, 0x06,
		0x44, 0xa6, 0x93, 0x2b, 0x12, 0xfb, 0xd0, 0x15, 0x79, 0x0b, 0xcd, 0xc4,
		0xab, 0xc4, 0xdf, 0xad, 0x9a, 0xe4, 0x94, 0xae, 0x85, 0x03, 0x1d, 0x5b,
		0x4d, 0x0c, 0x7d, 0x21, 0x1b, 0x53, 0xe9, 0xe1, 0x71, 0x72, 0x67, 0x75,
		0xef, 0xde, 0x17, 0xf7, 0x67, 0x35, 0xce, 0xc1, 0xdb, 0x11, 0x82, 0x0d,
		0x14, 0xde, 0x80, 0x5e, 0x43, 0x31, 0x58, 0xfe, 0xb6, 0xfa, 0x74, 0x07,
		0xc9, 0x57, 0xc1, 0x19, 0xbd, 0x8e, 0x77, 0x4f, 0xf4, 0x6b, 0x5f, 0x84,
		0x46, 0xab, 0x2b, 0x5c, 0x0b, 0x39, 0x31, 0x7c, 0x15, 0xa4, 0xc5, 0xfe,
		0xbf, 0x98, 0x24, 0x04, 0x0e, 0xc0, 0x56, 0x81};
	uint16_t out_values[24];
	int curr;
	char pass_in[128] = {0};

	//FLAG{1_c4n_r34d_4553mb1y}
	printf("Password?\n");
	fgets(pass_in, 128, stdin);
	rm_cr(pass_in, 128);
	if (strlen(pass_in) != 25)
		goto FAIL;

	for (curr = 0; curr < ((int)(strlen(pass_in) - 1)); curr++) {
		next_duet = *((uint16_t*)(pass_in + curr));
		next_duet = (next_duet << 8) | (next_duet >> 8);
		next_duet = (next_duet & 0xff00) |
				((next_duet & 0xf) << 4) |
				((next_duet & 0xf0) >> 4);
		next_duet = (next_duet & 0x00ff) |
				((next_duet & 0xf000) >> 4) |
				((next_duet & 0xf00) << 4);
		out_values[curr] = next_duet ^ *((uint16_t*)masks + curr);
	}

	for (curr = 0; curr < ((int)(sizeof(expected_vals) / sizeof(uint16_t))); curr++){
		if (expected_vals[curr] != out_values[curr])
			goto FAIL;
	}

	printf("OK\n");
	return 0;
FAIL:
	printf("Wrong.\n");
	return EINVAL;
}

